function  [w] = user_Hx( v,  Mmat )   
%
% Usage: [w] = user_Hx( v,  Mmat )
%
% compute matrix-vector products.
% the "Mmat" is optional, when it is omitted,
% a global matrix named "A" is necessary.
%
% 
% all matrix-vector products are performed through calls to
% this subroutine so that the MV count can be accurate.
% a global veriable "MVprod" is needed to count the 
% matrix-vector products
%  
% note that if Mmat is a string function, the interface here
% is not polished yet (since one usually needs to input more
% variables to @Mmat than just v)
%
  
  global A_operator
  global MVprod   %count the matrix-vector products
  
  if nargin == 1 
     w = A_operator * v;
  else
    if (isnumeric(Mmat))
      w = Mmat * v;
    else
      w = feval(Mmat, v);
    end
  end

  MVprod = MVprod+1;
  %MVprod = MVprod+size(v,1);

  
%end function user_Hx


%
%note that eigs.m handles a function-script with additional
%parameters as the following:  
%
% w= feval(A, workd(:,col3), ...
%             varargin{7-Amatrix-Bnotthere:end});
%
%(it should be easy to follow this example)
%